#include<allegro.h>
#include"paint.h"
#include"c4.h"

GameBoard SetupC4(int First)
{
 GameBoard theGame;
 
 theGame.SizeX = 7;
 theGame.SizeY = 6;
 theGame.Done = 0;
 theGame.MovesRemaining = theGame.SizeX * theGame.SizeY;
 theGame.PlayerTurn = First;
 theGame.Grid = (char **)malloc(theGame.SizeX * sizeof(char *));
 int i;
 for(i = 0; i < theGame.SizeX; i++)
   theGame.Grid[i] = (char *)malloc(theGame.SizeY * sizeof(char));

 int j;
 for(i = 0; i < theGame.SizeX; i++)
   for(j = 0; j < theGame.SizeY; j++)
     theGame.Grid[i][j] = '0';

 return theGame;
}

int CheckBoard(int X, GameBoard theGame, int InARow)
{
 int CurrentTotal = 1;
 int PosX = X;
 int Y;

 for(Y = 0; Y < theGame.SizeY; Y++)
 {
  if(theGame.Grid[X][Y] != '0') break;
 }

 int PosY = Y;

 int Block = 0;
 char Player = theGame.Grid[X][Y];

 while(!Block)
 {
  PosX--;
  if(PosX < 0 || theGame.Grid[PosX][PosY] != Player)
  {
   PosX = X;
   while(!Block)
   {
    PosX++;
    if(PosX > theGame.SizeX-1 || theGame.Grid[PosX][PosY] != Player)    
      Block = 1;
    else CurrentTotal++;
   }
  }
  else CurrentTotal++;
 }
 if(CurrentTotal >= InARow) return 1;
 else CurrentTotal = 1;

 Block = 0;
 PosX = X;
 PosY = Y;

 while(!Block)
 {
  PosY--;
  if(PosY < 0 || theGame.Grid[PosX][PosY] != Player)
  {
   PosY = Y;
   while(!Block)
   {
    PosY++;
    if(PosY > theGame.SizeY-1 || theGame.Grid[PosX][PosY] != Player)    
      Block = 1;
    else CurrentTotal++;
   }
  }
  else CurrentTotal++;
 }
 if(CurrentTotal >= InARow) return 1;
 else CurrentTotal = 1;

 Block = 0;
 PosX = X;
 PosY = Y;

 while(!Block)
 {
  PosY--;
  PosX--;
  if(PosY < 0 || PosX < 0 || theGame.Grid[PosX][PosY] != Player)
  {
   PosX = X;
   PosY = Y;
   while(!Block)
   {
    PosY++;
    PosX++;
    if(PosX > theGame.SizeX-1 || PosY > theGame.SizeY-1 || theGame.Grid[PosX][PosY] != Player) 
      Block = 1;
    else CurrentTotal++;
   }
  }
  else CurrentTotal++;
 }
 if(CurrentTotal >= InARow) return 1;
 else CurrentTotal = 1;

 Block = 0;
 PosX = X;
 PosY = Y;

 while(!Block)
 {
  PosY--;
  PosX++;
  if(PosY < 0 || PosX > theGame.SizeX-1 || theGame.Grid[PosX][PosY] != Player)
  {
   PosX = X;
   PosY = Y;
   while(!Block)
   {
    PosY++;
    PosX--;
    if(PosX < 0 || PosY > theGame.SizeY-1 || theGame.Grid[PosX][PosY] != Player) 
      Block = 1;
    else CurrentTotal++;
   }
  }
  else CurrentTotal++;
 }
 if(CurrentTotal >= InARow) return 1;
 else CurrentTotal = 1;

 return 0; 
}

GameBoard CollapseGrid(int X, GameBoard theBoard)
{
 int i;
 for(i = theBoard.SizeY-1; i > 0; i--)
 {
  if(theBoard.Grid[X][i] == '0' && i > 0 && theBoard.Grid[X][i-1] != '0')
  {
	theBoard.Grid[X][i] = theBoard.Grid[X][i-1];
	theBoard.Grid[X][i-1] = '0';
        ErasePiece(X,i-1);
	if(theBoard.Grid[X][i] == 'B')	PaintPiece(X,i,0);
	else PaintPiece(X,i,1);
	return theBoard;
  }
 }

 theBoard.Collapsible = 0;
 return theBoard;
}

void PlayC4()
{
 GameBoard C4 = SetupC4(0);
 int X = 3; 

 SetCursor(X, C4.PlayerTurn);
 DrawScreen();

 while((!key[KEY_ESC]) && C4.Done == 0)
 {
  readkey();
  EraseCursor(X);
  if(key[KEY_SPACE])
  {
   if(C4.Grid[X][0] == '0')
   {
    C4.Collapsible = 1;
    if(C4.PlayerTurn) 
    {
     C4.Grid[X][0] = 'B';
     PaintPiece(X,0,0);
     rest(100);
     DrawScreen();
    }
    else 
    {
     C4.Grid[X][0] = 'R';
     PaintPiece(X,0,1);
     rest(100);
     DrawScreen();
    }
    while(C4.Collapsible)
    {
	C4 = CollapseGrid(X, C4);
	rest(100);
	DrawScreen();
    }
    play_sample(Click, 255, 0, 1000, 0); 
    C4.PlayerTurn = (C4.PlayerTurn + 1) % 2;
    C4.MovesRemaining--;
    if(C4.MovesRemaining <= 0) C4.Done = 1;
    C4.Done += CheckBoard(X, C4, 4);
   }
  }
  if(key[KEY_LEFT]) X--;
  if(key[KEY_RIGHT]) X++;

  if(X > 6) X = 0;
  else if(X < 0) X = 6;
  if(!C4.Done) SetCursor(X, C4.PlayerTurn);
  DrawScreen();
 }
 if(!key[KEY_ESC])
 {
  text_mode(-1);

  if(C4.PlayerTurn)
  {
   textout(screen, font, "Red Wins!", 301, 201, makecol(0,0,0));
   textout(screen, font, "Red Wins!", 300, 200, makecol(255,255,255));
  }
  else 
  {
   textout(screen, font, "Black Wins!", 301, 201, makecol(0,0,0));
   textout(screen, font, "Black Wins!", 300, 200, makecol(255,255,255));
  }
  rest(3000);
 }

}


int main()
{
 initGame();
 PaintFromFile("c4.dat");
 PaintC4Board(); 
 DrawScreen();
 PlayC4();
 Shutdown();
 return 1;
}

